SystemOrganization addCategory: #'Magritte-Scriptaculous'!

!MAOptionDescription methodsFor: '*magritte-scriptaculous-override' stamp: 'kph 12/8/2007 18:33'!
optionsFor: item

	^ item readUsing: (MADescription basicNew accessor: (self accessor options ifNil: [ ^ self options ]))

! !

MATextInputComponent subclass: #MAAutoCompletingTextInputComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Scriptaculous'!

!MAAutoCompletingTextInputComponent commentStamp: 'kph 11/20/2007 00:12' prior: 0!
At present we obtain the list from the model, via the accessor supplied at:, #listAccessor
we can alternatively get it from the memento via a description obtained from the model class, #listDescriptionSelector

We also have an #inputExampleText property (as an addition to our superclass)

and #listMax!

!MAAutoCompletingTextInputComponent class methodsFor: 'as yet unclassified' stamp: 'kph 11/19/2007 04:32'!
isAbstract

 ^ false! !

!MAAutoCompletingTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 11/19/2007 20:27'!
list

	self listDescription ifNotNilDo: [ :desc | ^ self memento readUsing: desc  ].
	 
	self listModelAccessor ifNotNilDo: [ :accessor | ^ accessor read: self memento model  ].

	self error: 'see class comment for properties which need to be configured'.
! !

!MAAutoCompletingTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 11/19/2007 20:23'!
listDescription

	^ self memento model class perform: (self listDescriptionSelector ifNil:[ ^nil ])! !

!MAAutoCompletingTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 11/19/2007 20:21'!
listDescriptionSelector

	^ self description propertyAt: #listDescriptionSelector ifAbsent: nil! !

!MAAutoCompletingTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 11/20/2007 00:11'!
listMax
	^ self description propertyAt: #listMax ifAbsent: [ self listMaxDefault ]! !

!MAAutoCompletingTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 11/20/2007 00:12'!
listMaxDefault
	^  10! !

!MAAutoCompletingTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 11/19/2007 20:20'!
listModelAccessor

	^ self description propertyAt: #listAccessor! !

!MAAutoCompletingTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 11/20/2007 12:26'!
renderEditorOn: html
	| input p |
 
	p := self parent.
	
	input := self labelId.
	html textInput
		attributes: self attributes;
		id: input;
		value: self string;
		exampleText: self exampleText;
		"onChange: (html request
					triggerFormElement: input);"
		callback: [ :v | self string: v ].
		
	html div 
		class: 'autocomplete';
		script: (html autocompleter
		element: input;
		onSelected: ((html request
					triggerFormElement: input) onSuccess: (html updater id: (p id); callback: [ :r | self log info: p id.  p updateContentOn: r] ));
		on: #renderListOn: of: self)
		 ! !

!MAAutoCompletingTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 11/20/2007 00:12'!
renderListOn: html
	| items |
	
	items := self list select: [ :each | each name includesSubstring: self string caseSensitive: false ].

	html unorderedList list: (items first: (items size min: self listMax))! !

!MAAutoCompletingTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 11/19/2007 08:33'!
selectionHandlerOn: html ! !

!MAAutoCompletingTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 11/19/2007 22:19'!
style
	^ 'input#text {
	width: 250px;
}
div.autocomplete {
	position: absolute;
	background-color: white;
	border: 1px solid #888;
	margin: 0px;
	padding: 0px;
	z-index: 1000;
}
div.autocomplete ul, div.autocomplete ul li {
	list-style-type: none;
	line-height: 1.7;
	margin: 0px;
	padding: 0px;
}
div.autocomplete ul li.selected {
	background-color: #ffb;
}'! !

!MAComponentRenderer methodsFor: '*magritte-scriptaculous-override' stamp: 'kph 11/22/2007 05:31'!
renderContainer: aDescription
	self visitAll: (aDescription select: [ :each |
		(each isVisibleTest: (self childAt: each))
			and: [ each componentClass notNil ] ])! !

!MADescription methodsFor: '*magritte-scriptaculous-override' stamp: 'kph 12/14/2007 10:06'!
accessor: anAccessor
	accessor := anAccessor asAccessor! !

!MADescription methodsFor: '*magritte-scriptaculous' stamp: 'kph 11/22/2007 05:27'!
isVisibleTest: item
	 
	^ self isVisible and: [ item readUsing: 
		(MADescription basicNew accessor: (self accessor visible ifNil: [ ^ self isVisible ]))]! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 11/20/2007 11:01'!
asAccessor

^ self ! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 11/22/2007 04:38'!
options

   ^ self propertyAt: #options ifAbsent: [ nil ]! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 11/22/2007 04:39'!
options: selectorOrAccessor

   self propertyAt: #options put: selectorOrAccessor asAccessor
	
 ! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 11/21/2007 00:01'!
readonly 

   ^ self propertyAt: #readonly ifAbsent: [ nil ]! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 11/21/2007 00:01'!
readonly: selectorOrAccessor

   self propertyAt: #readonly put: selectorOrAccessor asAccessor
	
 ! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 12/14/2007 10:58'!
tooltip

   ^ self propertyAt: #tooltip ifAbsent: [ nil ]! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 12/14/2007 10:58'!
tooltip: selectorOrAccessor

   self propertyAt: #tooltip put: selectorOrAccessor asAccessor
	
 ! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 11/20/2007 11:01'!
update 

   ^ self propertyAt: #update ifAbsent: [ self ]! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 11/20/2007 10:56'!
update: selectorOrAccessor

   self propertyAt: #update put: selectorOrAccessor asAccessor
	
 ! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 11/20/2007 10:59'!
update: anObject to: aModel
	"Write ==anObject== to ==aModel== using the access-strategy of the receiver."

	self update write: anObject to: aModel! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 11/22/2007 04:36'!
visible 

   ^ self propertyAt: #visible ifAbsent: [ nil ]! !

!MAAccessor methodsFor: '*magritte-scriptaculous' stamp: 'kph 11/30/2007 00:34'!
visible: selectorOrAccessor

   self propertyAt: #visible put: selectorOrAccessor asAccessor
	
 ! !

!MAValidatorVisitor methodsFor: '*magritte-scriptaculous-override' stamp: 'kph 11/22/2007 05:53'!
visitDescription: aDescription
	"Validate the current object using aDescription within an exception handler to avoid running further tests that might cause error-cascades."

	(aDescription isVisibleTest: self object) ifFalse: [ ^ self ].
	[ self validate: self object using: aDescription ]
		on: MAValidationError
		do: [ :err | err beResumable; pass ]! !

!MAChainAccessor methodsFor: '*magritte-scriptaculous-override' stamp: 'kph 12/14/2007 10:07'!
accessor: anAccessor
	accessor := anAccessor asAccessor! !

!MAChainAccessor methodsFor: '*magritte-scriptaculous-override' stamp: 'kph 12/14/2007 10:07'!
next: anAccessor
	next := anAccessor asAccessor! !

!MAContainerComponent methodsFor: '*magritte-scriptaculous' stamp: 'kph 11/20/2007 12:17'!
updateContentOn: html
	self description componentRenderer
		component: self on: html! !

MASelectListComponent subclass: #MASelectListComponentSU
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Scriptaculous'!

!MASelectListComponentSU methodsFor: 'as yet unclassified' stamp: 'kph 11/20/2007 13:40'!
renderEditorOn: html

	

	html select
		attributes: self attributes;
		id: self labelId;
		list: self options;
		selected: self value;
		callback: [ :value | self value: value ];
		onChange: (html updater 
						id: (parent id); 
						triggerFormElement: (self labelId);
						callback: [ :r | self log info: parent id. self beep. parent updateContentOn: r] );
		labels: [ :value | self labelForOption: value ]! !

MAListCompositonComponent subclass: #MAListCompositonComponentSU
	instanceVariableNames: 'id availableId selectedId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Scriptaculous'!

!MAListCompositonComponentSU methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2007 10:26'!
formId

	^ self labelId, '-f'! !

!MAListCompositonComponentSU methodsFor: 'as yet unclassified' stamp: 'kph 11/13/2007 23:54'!
renderEditorAvailableOn: html

	html select
		attributes: self attributes;
		id: availableId;
		size: 6; style: 'width: 250px';
		list: self availableList;
		selected: self availableSelected;
		callback: [ :value | self availableSelected: value ];
		labels: [ :value | self labelForOption: value ]! !

!MAListCompositonComponentSU methodsFor: 'as yet unclassified' stamp: 'kph 9/26/2007 17:18'!
renderEditorButtonAddOn: html

	html button
		onClick:  (html updater
					id: id;
					triggerFormElement: availableId;
					callback: [ :r | self add; updateEditorOn: r ];
					return: false);
		with: '>>'.
	html break.
	html button
		onClick: (html updater
					id: id;
					triggerFormElement: selectedId;
					callback: [ :r | self remove; updateEditorOn: r ];
					return: false);
		with: '<<'! !

!MAListCompositonComponentSU methodsFor: 'as yet unclassified' stamp: 'kph 9/26/2007 17:18'!
renderEditorButtonOrderOn: html

	html button
		onClick:  (html updater
					id: id;
					triggerFormElement: selectedId;
					callback: [ :r | self moveUp; updateEditorOn: r ];
					return: false);
		text: 'up'.
	html break.
	html button
		onClick:  (html updater
					id: id;
					triggerFormElement: selectedId;
					callback: [ :r | self moveDown; updateEditorOn: r ]; 
					return: false);
		text: 'down'! !

!MAListCompositonComponentSU methodsFor: 'as yet unclassified' stamp: 'kph 9/26/2007 17:13'!
renderEditorOn: html 
	id := html nextId.
	availableId := html nextId.
	selectedId := html nextId.
	html div
		id: id;
		with: 
			 [self updateEditorOn: html] ! !

!MAListCompositonComponentSU methodsFor: 'as yet unclassified' stamp: 'kph 11/13/2007 23:54'!
renderEditorSelectedOn: html
 	html select
		attributes: self attributes;
		id: selectedId;
		size: 6; style: 'width: 250px';
		list: self selectedList;
		selected: self selectedSelected;
		callback: [ :value | self selectedSelected: value ];
		labels: [ :value | self labelForOption: value ]! !

!MAListCompositonComponentSU methodsFor: 'as yet unclassified' stamp: 'kph 9/16/2007 08:56'!
updateEditorOn: html
		super renderEditorOn: html! !

!MAListCompositonComponentSU methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2007 10:26'!
updateId

	^ self labelId, '-u'! !
